# coding: utf-8

import six

from huaweicloudsdkcore.sdk_response import SdkResponse
from huaweicloudsdkcore.utils.http_utils import sanitize_for_serialization


class BatchResetServersPasswordResponse(SdkResponse):

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    sensitive_list = []

    openapi_types = {
        'response': 'list[ServerId]'
    }

    attribute_map = {
        'response': 'response'
    }

    def __init__(self, response=None):
        """BatchResetServersPasswordResponse

        The model defined in huaweicloud sdk

        :param response: 提交请求成功后返回的响应列表。
        :type response: list[:class:`huaweicloudsdkecs.v2.ServerId`]
        """
        
        super(BatchResetServersPasswordResponse, self).__init__()

        self._response = None
        self.discriminator = None

        if response is not None:
            self.response = response

    @property
    def response(self):
        """Gets the response of this BatchResetServersPasswordResponse.

        提交请求成功后返回的响应列表。

        :return: The response of this BatchResetServersPasswordResponse.
        :rtype: list[:class:`huaweicloudsdkecs.v2.ServerId`]
        """
        return self._response

    @response.setter
    def response(self, response):
        """Sets the response of this BatchResetServersPasswordResponse.

        提交请求成功后返回的响应列表。

        :param response: The response of this BatchResetServersPasswordResponse.
        :type response: list[:class:`huaweicloudsdkecs.v2.ServerId`]
        """
        self._response = response

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                if attr in self.sensitive_list:
                    result[attr] = "****"
                else:
                    result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        import simplejson as json
        if six.PY2:
            import sys
            reload(sys)
            sys.setdefaultencoding("utf-8")
        return json.dumps(sanitize_for_serialization(self), ensure_ascii=False)

    def __repr__(self):
        """For `print`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BatchResetServersPasswordResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
